################################################################################
#
# System:  "2C42-65"
# Machine: "-250A"
# Type: MILL  2.5
# version xx.xx.xx (28.03.2003 13:53)
# Russia, KnAAPO,OGT,SPC(Sector of the Program Control,#"  ")
# Author's : evgene.
#
################################################################################
#
# $HISTORY$
################################################################################
# ------------------------------------- VARIABLES  --------------------------------------------
#
global circleNumber 	      ; set circleNumber 0	    ; #       (   )
global mom_time		      ; set mom_time   OFF  	    ; #  
global first_tool 	      ; set first_tool 0	    ; #  1- 
global  flagCutcom_begin      ; set flagCutcom_begin 	0   ; #   
global mom_rewind_end_of_program ; set mom_rewind_end_of_program     0 ; #   M02|M30
#
global subprogram_text        ; set subprogram_text              "" ;
global def_subprogram_code    ; set def_subprogram_code           0 ;
global start_subprogram_code  ; set start_subprogram_code         0 ;
global number_subprogram      ; set number_subprogram             0 ; #  
global flag_subprogram        ; set flag_subprogram               0 ;
global stloop_text            ; set stloop_text                  "" ;
global stloop_code            ; set stloop_code                   0 ;
#
#   
 global   SLOWDN_MIN_ANGLE  SLOWDN_MAX_FEED  SLOWDN_ACCELERATION
 global   mom_modes_slowdn
 global   mom_slowdn_min_angle
  set SLOWDN_MIN_ANGLE     "3.0"
  set SLOWDN_MAX_FEED      "600.0"
  set SLOWDN_ACCELERATION  "5"
#    ( )
  set mom_modes_slowdn       "OFF"  ;
  set mom_slowdn_min_angle $SLOWDN_MIN_ANGLE;
################################################################################

  set cam_post_dir  [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]

#proc MOM_before_each_add_var {} {}
#proc MOM_before_each_event {} {}
source ${cam_debug_dir}mom_review.tcl ;
   MOM_set_debug_mode OFF

#_______________________________________________________________________________
#The following command invokes the warning mode and the default settings.
#_______________________________________________________________________________
  source ${cam_post_dir}/ugpost_base.tcl

 if { ![info exists mom_sys_post_initialized] } {

########## SYSTEM VARIABLE DECLARATIONS ##############
  set mom_sys_rapid_code                        "0"
  set mom_sys_linear_code                       "1"
  set mom_sys_circle_code(CLW)                  "2"
  set mom_sys_circle_code(CCLW)                 "3"
  set mom_sys_delay_code(SECONDS)               "4"
  set mom_sys_delay_code(REVOLUTIONS)           "4"
  set mom_sys_delay_code(SLOWDN)                "9"
  set mom_sys_cutcom_plane_code(XY)             "17"
  set mom_sys_cutcom_plane_code(ZX)             "18"
  set mom_sys_cutcom_plane_code(YZ)             "19"
  set mom_sys_cutcom_code(OFF)                  "40"
  set mom_sys_cutcom_code(LEFT)                 "41"
  set mom_sys_cutcom_code(RIGHT)                "42"
  set mom_sys_adjust_code(PLUS)                 "43"
  set mom_sys_adjust_code(MINUS)                "44"
  set mom_sys_adjust_code(OFF)                  "40"
#
  set mom_sys_cycle_off                         "80"  ; #  

#
  set mom_sys_cycle_drill_code                  "81"
  set mom_sys_cycle_drill_dwell_code            "82"
  set mom_sys_cycle_drill_deep_code             "83"
  set mom_sys_cycle_drill_break_chip_code       "83"
#
  set mom_sys_cycle_tap_code                    "84"
#
  set mom_sys_cycle_bore_code                   "85"
  set mom_sys_cycle_bore_drag_code              "86"
  set mom_sys_cycle_bore_dwell_code             "89"
  set mom_sys_cycle_bore_manual_code            "88"
  set mom_sys_cycle_bore_back_code              "87"
  set mom_sys_cycle_bore_manual_dwell_code      "88"
#
  set mom_sys_output_code(ABSOLUTE)             "90"
  set mom_sys_output_code(INCREMENTAL)          "91"
  set mom_sys_reset_code                        "25"
  set mom_sys_return_code                       "26"
  set mom_sys_program_stop_code                 "0"
  set mom_sys_optional_stop_code                "1"
  set mom_sys_end_of_program_code               "2"
#
set mom_sys_end_of_subprogram_code              "17"
#
  set mom_sys_spindle_direction_code(CLW)       "3"
  set mom_sys_spindle_direction_code(CCLW)      "4"
  set mom_sys_spindle_direction_code(OFF)       "5"
  set mom_sys_spindle_direction_code(ORIENT)    "19"
  set mom_sys_tool_change_code                  "6"
  set mom_sys_coolant_code(MIST)                "7"
  set mom_sys_coolant_code(ON)                  "8"
  set mom_sys_coolant_code(FLOOD)               "8"
  set mom_sys_coolant_code(TAP)                 "8"
  set mom_sys_coolant_code(OFF)                 "9"
  set mom_sys_rewind_code                       "30"
  set mom_sys_wcs_change_code                   "53"
#
  set mom_sys_spindle_ranges                    "4"
  set mom_sys_spindle_range_code(1)             "38"
  set mom_sys_spindle_range_code(2)             "39"
  set mom_sys_spindle_range_code(3)             "40"
  set mom_sys_spindle_range_code(4)             "41"
  set mom_sys_spindle_range_code(38)            "38"
  set mom_sys_spindle_range_code(39)            "39"
  set mom_sys_spindle_range_code(40)            "40"
  set mom_sys_spindle_range_code(41)            "41"
	set mom_sys_spindle_param(0,min)        "0"
	set mom_sys_spindle_param(0,max)        "500"
#
  set mom_sys_rewind_stop_code                  "%"
  set mom_sys_home_pos(0)                       "0"
  set mom_sys_home_pos(1)                       "0"
  set mom_sys_home_pos(2)                       "0"
  set mom_sys_zero                              "0"
  set mom_sys_opskip_block_leader               "/"
  set mom_sys_seqnum_start                      "1"
  set mom_sys_seqnum_incr                       "1"
  set mom_sys_seqnum_freq                       "1"
  set mom_sys_leader(N)                         "N"
  set mom_sys_contour_feed_mode(LINEAR)         "MMPM"
  set mom_sys_contour_feed_mode(ROTARY)         "MMPM"
  set mom_sys_contour_feed_mode(LINEAR_ROTARY)  "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "MMPM"
  set mom_sys_rapid_feed_mode(ROTARY)           "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR_ROTARY)    "MMPM"
  set mom_sys_feed_param(IPM,format)            "Feed_IPM"
  set mom_sys_feed_param(FRN,format)            "Feed_INV"
  set mom_sys_feed_param(DPM,format)            "Feed_DPM"
  set mom_sys_feed_param(MMPM,format)           "Feed_MMPM"
  set mom_sys_feed_param(MMPR,format)           "Feed_MMPR"
  set mom_sys_cycle_feed_mode                   "MMPM"
  set mom_sys_control_out                       "("
  set mom_sys_control_in                        ")"

####### KINEMATIC VARIABLE DECLARATIONS ##############
 set mom_kin_4th_axis_ang_offset               "0.0"
  set mom_kin_4th_axis_center_offset(0)         "0.0"
  set mom_kin_4th_axis_center_offset(1)         "0.0"
  set mom_kin_4th_axis_center_offset(2)         "0.0"
  set mom_kin_4th_axis_direction                "MAGNITUDE_DETERMINES_DIRECTION"
  set mom_kin_4th_axis_leader                   "B"  
  set mom_kin_4th_axis_limit_action             "Warning"
  set mom_kin_4th_axis_max_limit                "360"
  set mom_kin_4th_axis_min_incr                 "15"
  set mom_kin_4th_axis_min_limit                "0"  
  set mom_kin_4th_axis_plane                    "XZ" 
  set mom_kin_4th_axis_rotation                 "standard"
  set mom_kin_4th_axis_type                     "Table"
  set mom_kin_4th_axis_zero                     "0.0"

  set mom_kin_arc_output_mode                   "FULL_CIRCLE" ; # FULL_CIRCLE  LINEAR QUADRANT
  set mom_kin_arc_valid_planes                  "XYZ" ;      # ANY
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_linearization_flag                "F"
  set mom_kin_linearization_tol                 "0.001"
  set mom_kin_machine_resolution                "0.001"
  set mom_kin_machine_type                      "4_axis_table" 
  set mom_kin_max_arc_radius                    "999.998"
  set mom_kin_max_dpm                           "100"
  set mom_kin_max_fpm                           "3000"
  set mom_kin_max_fpr                           "2500"
  set mom_kin_max_frn                           "3000"
  set mom_kin_min_arc_length                    "0.025"
  set mom_kin_min_arc_radius                    "0.016"
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.0"
  set mom_kin_min_fpr                           "0.0"
  set mom_kin_min_frn                           "0.0"
  set mom_kin_output_unit                       "MM"
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "9999.999"
  set mom_kin_tool_change_time                  "12.0"
  set mom_kin_x_axis_limit                      "250" ; # 4000
  set mom_kin_y_axis_limit                      "280" ; # 4000
  set mom_kin_z_axis_limit                      "200" ; # 3500
  set mom_kin_read_ahead_next_motion            "true"

####  Listing File variables
  set mom_sys_list_output                       "ON"
  set mom_sys_header_output                     "ON"
  set mom_sys_list_file_rows                    "120"
  set mom_sys_list_file_columns                 "250"
  set mom_sys_warning_output                    "ON"
  set mom_sys_group_output                      "OFF"
  set mom_sys_list_file_suffix                  "lpt"
  set mom_sys_output_file_suffix                "up"
  set mom_sys_commentary_output                 "ON"
  set mom_sys_commentary_list                   "x y z feed speed"
    set mom_coolant_status "ON"
   set mom_sys_post_initialized 1
   
   set leader_4th  "B"

  }

############################################################################

#=============================================================
proc MOM_start_of_program { } {
#=============================================================
  global mom_logname mom_date is_from
  global mom_coolant_mode mom_coolant_status
  global mom_cutcom_mode mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register

    set pb_start_of_program_flag 0
    set mom_coolant_status "ON"
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED

  catch {unset mom_coolant_mode}
  catch {unset mom_coolant_status}
  catch {unset mom_cutcom_mode}
  catch {unset mom_cutcom_status}

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    set is_from ""

    OPEN_files ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing

  global mom_sys_post_initialized
  if { $mom_sys_post_initialized > 1 } { return }


#************
uplevel #0 {


#=============================================================
proc MOM_sync {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_handle_sync_event] ] {
    PB_CMD_kin_handle_sync_event
  }
}


#=============================================================
proc MOM_set_csys {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_set_csys] ] {
    PB_CMD_kin_set_csys
  }
}


#=============================================================
proc MOM_msys {} {
#=============================================================
}


##=============================================================
#proc MOM_end_of_program { } {
##=============================================================
#   MOM_do_template end_of_program
#   MOM_set_seq_off
#
##**** The following procedure lists the tool list with time in commentary data
#   LIST_FILE_TRAILER
#
##**** The following procedure closes the warning and listing files
#   CLOSE_files
#}

  incr mom_sys_post_initialized

} ;# uplevel
#***********

}


#=============================================================
proc PB_start_of_program { } {
#=============================================================
global  mom_warning_info
global  mom_output_file_basename
global  mom_logname  mom_date

   if { [llength [info commands PB_CMD_kin_start_of_program]] } {
      PB_CMD_kin_start_of_program
   }

  set mom_warning_info "\n   242-65 ( ISO)."
  MOM_output_to_listing_device $mom_warning_info  ;  # MOM_catch_warning ;

  set mom_warning_info "\n :\n"
  append mom_warning_info "\tG01 -  \n"
  append mom_warning_info "\tG17 -   (XY)\n"
  append mom_warning_info "\tG23 -     \n"
  append mom_warning_info "\tG36 -   \n"
  append mom_warning_info "\tG40 -       \n"
  append mom_warning_info "\tG90 -  \n"
  append mom_warning_info "\tG53 -    \n"
  append mom_warning_info "\tM78 -   X\n"
  append mom_warning_info "\tM80 -   Y\n"
  append mom_warning_info "\tM82 -   Z\n"
  append mom_warning_info "\tM84 -   \n"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;

  global mom_sys_rewind_stop_code
  set str "$mom_sys_rewind_stop_code"

  global partno_program
  if {[info exists partno_program]} {
    if {$partno_program != ""} { append str $partno_program }
   }

   MOM_set_seq_off
    MOM_output_literal "N1)"
   MOM_output_literal "$str"
   MOM_set_seq_on
   set tmp [ clock seconds ]
   set tmp [ clock format $tmp  -format  "%d.%m.%Y" ] ; # "%d.%m.%Y  %H:%M"
   # $mom_logname
#   MOM_output_literal "( =$mom_output_file_basename ,$tmp)"

 ; #    
   global   mom_adjust_mode ;  set mom_adjust_mode  OFF

   MOM_force Once G_plane G_mode
   MOM_suppress always D G_cutcom; # G_adjust

 # 
  global SLOWDN_MIN_ANGLE  SLOWDN_MAX_FEED  SLOWDN_ACCELERATION
  global mom_modes_slowdn
  global mom_slowdn_min_angle
  # 
  set SLOWDN_MIN_ANGLE     "3.0"
  set SLOWDN_MAX_FEED      "600.0"
  set SLOWDN_ACCELERATION  "5"
 ;#     
  set mom_modes_slowdn     "AUTO"  ;
  set mom_slowdn_min_angle $SLOWDN_MIN_ANGLE;
  global mom_user_defined_text mom_record_fields
  set mom_record_fields(0) SLOWDN
  set mom_record_fields(1) $mom_modes_slowdn
#  MOM_text

  #catch { PB_mirror }
  #catch { PB_slowdn_load }

}

#=============================================================
proc PB_CMD_machine_mode { } {
#=============================================================
  global mom_output_mode mom_arc_mode mom_prev_machine_mode mom_machine_mode mom_feed_set_mode
  set mom_output_mode     	"ABSOLUTE"
  set mom_prev_machine_mode  	"MILL"
  set mom_machine_mode 		"MILL" ;
  set mom_arc_mode     		"CIRCULAR" ;
  set mom_feed_set_mode 	"MMPM" ;
}

#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  catch {PB_CMD_machine_mode} errMes ; MOM_log_message "$errMes" ;
}


#=============================================================
proc MOM_start_of_group {} {
#=============================================================
  global mom_sys_group_output mom_group_name group_level ptp_file_name
  global mom_sequence_number mom_sequence_increment mom_sequence_frequency
  global mom_sys_ptp_output pb_start_of_program_flag

    if {![hiset group_level]} {set group_level 0 ; return}

    if {[hiset mom_sys_group_output]} {if {$mom_sys_group_output == "OFF"} {set group_level 0 ; return}}

    if {[hiset group_level]} {incr group_level} else {set group_level 1}
    if {$group_level > 1} {return}

    SEQNO_RESET ; #<4133654>
    MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency

    if {[info exists ptp_file_name]} {
      MOM_close_output_file $ptp_file_name ; MOM_start_of_program
      if {$mom_sys_ptp_output == "ON"} {MOM_open_output_file $ptp_file_name }
    } else {
      MOM_start_of_program
    }

    PB_start_of_program ; set pb_start_of_program_flag 1
}


############## EVENT HANDLING SECTION ################

#=============================================================
proc MOM_start_of_path { } {
#=============================================================
  global pb_start_of_program_flag

    if {$pb_start_of_program_flag == 0} {
      PB_start_of_program ;
      #MOM_force once S M_spindle X Y Z F
      set pb_start_of_program_flag 1
    }
  
   TOOL_SET MOM_start_of_path

  global  var_start_of_path_num ;incr var_start_of_path_num ; #   

}

proc MOM_start_of_path {} {
#=============================================================
# This procedure is executed at the begining of each path in the task
# It gets called after all the general parameters of the path are loaded
# like the path name and the tool name.
#=============================================================
  global pb_start_of_program_flag
  if {$pb_start_of_program_flag == 0} {
	PB_start_of_program

#-------------------------------------------------------
  global mom_update_post_cmds_from_tool
  if {[info exists mom_update_post_cmds_from_tool]} {
   if {$mom_update_post_cmds_from_tool==1} {

uplevel #0 {

      proc MOM_first_tool { } {
      	global mom_tool_change_type mom_manual_tool_change

      	if {[info exists mom_tool_change_type]} {
      		switch $mom_tool_change_type {
      			MANUAL { PB_manual_tool_change }
      			AUTO { PB_auto_tool_change }
      		}
      	} elseif {[info exists mom_manual_tool_change]} {
      		if {$mom_manual_tool_change == "TRUE"} {
      			PB_manual_tool_change
      		}
      	}
      }

      ;#=============================================================
      proc MOM_tool_change { } {
      ;#=============================================================

      	MOM_do_template end_of_path_spindle_coolant_off

      	global mom_tool_change_type mom_manual_tool_change
      	if {[info exists mom_tool_change_type]} {
      		switch $mom_tool_change_type {
      			MANUAL { PB_manual_tool_change }
      			AUTO { PB_auto_tool_change }
      		}
      	} elseif {[info exists mom_manual_tool_change]} {
      		if {$mom_manual_tool_change == "TRUE"} {
      			PB_manual_tool_change
      		}
      	}
      }

      ;#=============================================================
      proc MOM_load_tool { } {
      ;#=============================================================
      	global mom_tool_change_type mom_manual_tool_change
      }

    } ; # uplevel
  } ; # if
 } ; # if
#-------------------------------------------------------

   }
  incr pb_start_of_program_flag 1 ; #   TRAORI

  global mom_sys_in_operation
   set mom_sys_in_operation 1

  global first_linear_move ; set first_linear_move 0
   TOOL_SET MOM_start_of_path

   if [llength [info commands PB_CMD_kin_start_of_path] ] {
      PB_CMD_kin_start_of_path
   }

  MOM_force once G_motion F

}



#=============================================================
proc MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type  mom_current_motion RAD2DEG
  global mom_out_angle_pos mom_pos mom_mcs_goto
  global mom_mcs_goto mom_prev_mcs_goto
  global mom_pos_arc_center mom_arc_center
  FEEDRATE_SET

  global g_plane  ;  set g_plane [CHECK_PLANE]

    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
    }

    if { [llength [info commands PB_CMD_kin_before_motion]] } { PB_CMD_kin_before_motion }
    if { [llength [info commands PB_CMD_before_motion]] }     { PB_CMD_before_motion }
    
 
#   
	if {  $mom_out_angle_pos(0)!=0.0 } {

		set a2 [ expr (cos($mom_out_angle_pos(0)/$RAD2DEG))]
		set b2 [ expr (sin($mom_out_angle_pos(0)/$RAD2DEG))]

     set   mom_pos(0) [ expr ($mom_mcs_goto(0)*$a2-$mom_mcs_goto(2)*$b2)]
     set   mom_pos(2) [ expr ($mom_mcs_goto(0)*$b2+$mom_mcs_goto(2)*$a2)]
     
     set   mom_prev_pos(0) [ expr ($mom_prev_mcs_goto(0)*$a2-$mom_prev_mcs_goto(2)*$b2)]
     set   mom_prev_pos(2) [ expr ($mom_prev_mcs_goto(0)*$b2+$mom_prev_mcs_goto(2)*$a2)]
     
     set   mom_pos_arc_center(0) [ expr ($mom_arc_center(0)*$a2-$mom_arc_center(2)*$b2)]
     set   mom_pos_arc_center(2) [ expr ($mom_arc_center(0)*$b2+$mom_arc_center(2)*$a2)]
}

}


#=============================================================
proc MOM_from_move { } {
#=============================================================
# This procedure is called for a FROM statement
 catch { RAPID_SET ; }  errMes ; MOM_log_message "$errMes" ;
catch { MOM_do_template from CREATE } errMes ; MOM_log_message "$errMes" ;
 MOM_force ONCE X Y
}


#=============================================================
proc MOM_initial_move { } {
#=============================================================
# This procedure is executed for the initial move of each operation.  It
# assumes the tool is moving from a safe position at rapid to the start of
# the operation.
  MOM_force once G_motion F ;# X Y ; # Z M_cool

  global mom_warning_info mom_out_angle_pos
  global mom_update_post_cmds_from_tool
  
     set a $mom_out_angle_pos(0)
    set b 0
		for { set nn 0 } { $nn <= 360 } { set nn [expr $nn+15]} {
#			MOM_output_literal "$nn============"
		if {$a == $nn} {
		set b 1
		    }
	}
                if {$b == 0} {

		      set mom_warning_info "Warning:    B"
 	      MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
 	}
  	MOM_do_template rapid_b
  	
  if {[info exists mom_update_post_cmds_from_tool]} {
    if {$mom_update_post_cmds_from_tool==1} {

        global mom_spindle_rpm
        if {[info exists mom_spindle_rpm] != 0} {
           if {$mom_spindle_rpm != 0.0} {
           	
	      MOM_spindle_rpm
           } else {
		      set mom_warning_info "Warning:     !" 	    
 	      MOM_output_to_listing_device $mom_warning_info  ;    MOM_catch_warning ;
           }
        }

    }
   }

   global mom_motion_event  mom_motion_type
   global mom_programmed_feed_rate  mom_feed_rate  mom_kin_rapid_feed_rate
   if { [EQ_is_equal $mom_programmed_feed_rate 0.0] || [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate ] } {
      MOM_rapid_move
   } else {
        if {$mom_motion_event == "rapid_move"} { MOM_rapid_move; return ;  }
  	if {$mom_motion_type == "RAPID"} { MOM_rapid_move ; return ; }
      MOM_linear_move
   }

}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  catch { COOLANT_SET ; SPINDLE_SET ; RAPID_SET }  errMes ; MOM_log_message "$errMes" ;
  global  mom_motion_event mom_out_angle_pos mom_warning_info
  
     set a $mom_out_angle_pos(0)
    set b 0
		for { set nn 0 } { $nn <= 360 } { set nn [expr $nn+15]} {
#			MOM_output_literal "$nn============"
		if {$a == $nn} {
		set b 1
		    }
	}
                if {$b == 0} {

		      set mom_warning_info "Warning:    B"
 	      MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
 	}
  	MOM_do_template rapid_b
  catch {MOM_$mom_motion_event} errMes ; MOM_log_message "$errMes" ;
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
   MOM_do_template gohome
}


  set accumulated_time 0
#=============================================================
proc MOM_end_of_path { } {
#=============================================================
# This procedure is executed at the end of a path.
  global mom_operation_name    mom_path_name
  global mom_machine_time
  global accumulated_time

  set op_time [expr $mom_machine_time - $accumulated_time]
  global mom_time
  if {[info exists mom_time]} {
    if {$mom_time=="ON"} {
      global pb_start_of_program_flag  ; #   
      MOM_output_literal "(  . $pb_start_of_program_flag=[format "%.2f" $op_time] )"
     }
  }
  set accumulated_time $mom_machine_time

}


#=============================================================
proc MOM_end_of_program { } {
#=============================================================
# This procedure is executed at the end of the program after all the paths are traversed.
  global mom_part_name
  global mom_warning_info
  global mom_output_file_basename

  global mom_machine_time
  MOM_output_to_listing_device "\n********************************************************************************"
  set str1 "    =[format "%.2f" $mom_machine_time ] "
  set str2 [ outTime $mom_machine_time ]
  MOM_output_to_listing_device "$str1  $str2"  ;

  global mom_time
  if {[info exists mom_time]} {
    if {$mom_time=="ON"} { MOM_output_literal "$str2" ; }
  }

  MOM_output_to_listing_device "********************************************************************************"

  MOM_do_template end_of_path_spindle_coolant_off
  MOM_do_template end_of_program

  MOM_set_seq_off

  LIST_FILE_TRAILER ; #**** The following procedure lists the tool list with time in commentary data
  CLOSE_files ; #**** The following procedure closes the warning and listing files

}


#=============================================================
proc MOM_spindle_rpm { } {
#=============================================================
   global mom_spindle_text   mom_spindle_direction

   SPINDLE_SET

   if {[info exists  mom_spindle_direction]} {
      if {[string toupper $mom_spindle_direction]=="ORIENT"} {
      
           set mom_warning_info "WARNING:    (M19)"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           MOM_force Once M_spindle
           MOM_do_template spindle_orient
           return ;
      	}
   }

   if {[info exists  mom_spindle_text]} {
      if {[string toupper $mom_spindle_text]=="ORIENT"} {
      		
      	   set mom_spindle_direction  ORIENT ;
           set mom_warning_info "WARNING:    (M19)"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           MOM_force Once M_spindle
           MOM_do_template spindle_orient
           return ;
      	}
   }
	
   MOM_force Once  M_spindle 
   MOM_do_template spindle_rpm
   MOM_do_template spindle_direct
}


#=============================================================
proc MOM_spindle_css { } {
#=============================================================
# This procedure is executed when the Spindle command is activated SFM/SMM mode.
  global mom_spindle_status mom_spindle_mode
  set mom_spindle_status $mom_spindle_mode

  if {$mom_spindle_mode == "SFM" || $mom_spindle_mode == "SMM"} {
     SPINDLE_SET
  }

}

#=============================================================
proc MOM_spindle_off { } {
#=============================================================
   global mom_spindle_text   mom_spindle_direction
   if {[info exists  mom_spindle_text]} {
      if {[string toupper $mom_spindle_text]=="ORIENT"} {
           set mom_warning_info "WARNING:    (M19)"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           MOM_force once M_spindle
           MOM_do_template spindle_orient
      	}
   }
   MOM_do_template spindle_off
}


#=============================================================
proc MOM_coolant_on { } {
#=============================================================
# This procedure is executed when the Coolant command is activated.
	COOLANT_SET
	global mom_coolant_status  mom_coolant_mode
 	set mom_coolant_status $mom_coolant_mode
 	MOM_force Once M_coolant
	MOM_do_template coolant_on
}


#=============================================================
proc MOM_coolant_off { } {
#=============================================================
# This procedure is executed when the Coolant command is deactivated.
   	MOM_do_template coolant_off
}


#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
# This procedure is executed when the Cutcom command is activated.
  global mom_cutcom_status  mom_cutcom_mode ;
  set mom_cutcom_status $mom_cutcom_mode
  MOM_force once G_cutcom D
  ;#
  global flagCutcom_begin ; 	set flagCutcom_begin 	1 ;
  ;#
  global g_plane ; set g_plane [CHECK_PLANE] ;
  MOM_do_template plane ;
}


#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
# This procedure is executed when the Cutcom command is deactivated.
 global mom_cutcom_status  mom_cutcom_mode  mom_sys_cutcom_code
 MOM_force once G_cutcom
 MOM_force off D
 MOM_do_template cutcom_off
 catch {unset mom_cutcom_mode}
 ;#
 global flagCutcom_begin ; 	set flagCutcom_begin 	0 ;
 ;#
}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
  global mom_motion_event  mom_motion_type

  global feed_mode mom_feed_rate mom_kin_rapid_feed_rate
  if { $feed_mode == "IPM" || $feed_mode == "MMPM" } {
      if { [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate] } {
         MOM_rapid_move
         return
      }
   }
  if {$mom_motion_type == "RAPID"} { MOM_rapid_move ; return ; }

  global mom_cutcom_mode  mom_cutcom_status
  if {[info exists mom_cutcom_mode]} {  set mom_cutcom_status $mom_cutcom_mode ; }

  global  mom_spindle_speed
  if {[info exists mom_spindle_speed]} {
    if {$mom_spindle_speed==0.0} { MOM_suppress once S M_spindle; }
  }

#  catch { PB_slowdn_move } ; #  

  set str [MOM_do_template linear_move CREATE]

 global flagCutcom_begin
 if {$flagCutcom_begin==1} {

   set flG  0
   set flG [regexp -nocase -- {(G)(41)+|(G)(42)+} $str ]

   global mom_mill_spindle_axis
   global g_plane
   set flvar 0
   switch $g_plane {
     "17" { ;# XY
     	   set flvar [regexp -nocase -- {(Z)+} $str ];
     	  }
     "18" { ;# XZ
 	   set flvar [regexp -nocase -- {(Y)+} $str ];
     	  }
     "19" { ;# YZ
     	   set flvar [regexp -nocase -- {(X)+} $str ];
      	  }
    }

   set st [expr $flvar+$flG ]
   if {$st==2} {
   	set var0 ""
   	set fl [regsub -nocase -- {(G)(41)+|(G)(42)+}  $str "" var0 ]
   	set str $var0
   	MOM_force once G_cutcom
   	global mom_warning_info mom_seqnum
   	set nm [format "%.0f" $mom_seqnum ]
   	set mom_warning_info "!:   (G41|G42)     \{$nm\}    ."
   	append mom_warning_info "\n\t !  (G41|G42)         !"
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
    }

  }

  MOM_output_literal "$str"

}


#=============================================================
proc MOM_circular_move { } {
#==================================================================
# This procedure is executed for each circular move. It gets called after
# the circle data are loaded (end point and center).
  global mom_pos_arc_axis    mom_pos  mom_pos_arc_plane  mom_pos_arc_center
  global mom_output_mode
  global mom_cutcom_mode   mom_cutcom_status

  CIRCLE_SET
  global g_plane ;  set g_plane [CHECK_PLANE]

  global mom_cutcom_mode  mom_cutcom_status
  if {[info exists mom_cutcom_mode]} {  set mom_cutcom_status $mom_cutcom_mode ; }

  switch $g_plane {
        "17" { MOM_suppress once K Z; MOM_force once  I J X Y; }
        "18" { MOM_suppress once J Y; MOM_force once  I K X Z; }
        "19" { MOM_suppress once I X; MOM_force once  J K Y Z; }
       }

#  if {$g_plane != "NONE"}  { MOM_do_template plane }

  global  mom_spindle_speed
  if {[info exists mom_spindle_speed]} {
    if {$mom_spindle_speed==0.0} { MOM_suppress once S M_spindle; }
  }

#  catch { PB_slowdn_move } ; #  

  switch $mom_output_mode {
      ABSOLUTE { MOM_do_template circular_move_absolut  }
       default { MOM_do_template circular_move_incr  }
   }

}


#=============================================================
proc MOM_rapid_move { } {
#=============================================================
# This procedure is executed for each rapid move. It gets called after
# the positioning varables, position and tool axis (X,Z,TAX,TAY,TAZ) are loaded.
  global rapid_spindle_inhibit rapid_traverse_inhibit
  global spindle_first is_from
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2
  global mom_motion_event

  global mom_coolant_mode  mom_coolant_status
  if {[info exists mom_coolant_mode]} { set mom_coolant_status $mom_coolant_mode ; }

  global  mom_spindle_speed
  if {[info exists mom_spindle_speed]} {
    if {$mom_spindle_speed==0.0} { MOM_suppress once S M_spindle; }
  }

   set aa(0) X ; set aa(1) Y ; set aa(2) Z
   RAPID_SET
   set spindle_block rapid_spindle
   set traverse_block rapid_traverse
   if {$spindle_first == "TRUE"} {
    if {$rapid_spindle_inhibit == "FALSE"} {
          MOM_suppress once $aa($traverse_axis1) $aa($traverse_axis2)
          MOM_do_template $spindle_block $is_from
          MOM_suppress off $aa($traverse_axis1) $aa($traverse_axis2)
    }
    if {$rapid_traverse_inhibit == "FALSE"} {
       MOM_suppress once $aa($mom_cycle_spindle_axis)
       MOM_do_template $traverse_block $is_from
       MOM_suppress off $aa($mom_cycle_spindle_axis)
    }
  } elseif {$spindle_first == "FALSE"} {
    if {$rapid_traverse_inhibit == "FALSE"} {
       MOM_suppress once $aa($mom_cycle_spindle_axis)
       MOM_do_template $traverse_block $is_from
       MOM_suppress off $aa($mom_cycle_spindle_axis)
    }
    if {$rapid_spindle_inhibit == "FALSE"} {
       MOM_suppress once $aa($traverse_axis1) $aa($traverse_axis2)
       MOM_do_template $spindle_block $is_from
       MOM_suppress off $aa($traverse_axis1) $aa($traverse_axis2)
    }
  } else {
       MOM_do_template $traverse_block $is_from
  }

}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================
 # This command can be used to output a special sequence number character.
 # Replace the ":" with any character that you require.
  global mom_sys_leader  mom_coolant_status mom_tool_number mom_warning_info
  
  set saved_seq_num $mom_sys_leader(N)
  set mom_sys_leader(N) ":" ;# -    

#  MOM_force once G_adjust D
  MOM_suppress always G_adjust D
  MOM_force Once G_mode G Z
  if {$mom_tool_number == 0} {
	set mom_warning_info "       ."
 	      MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
 	}
  global mom_tool_text
  MOM_suppress ONCE Text
  if {[info exists mom_tool_text]} {
    if {$mom_tool_text != ""} { MOM_force Once Text }
  }

  MOM_force Once T ; # M  -    
  catch { MOM_do_template tool_change } errMes ; MOM_log_message "$errMes" ;
 # catch { MOM_do_template tool_change_next CREATE } errMes ; MOM_log_message "$errMes" ;

  PB_CMD_start_of_operation_force_addresses

#  Return sequnece number back to orignal
  set mom_sys_leader(N) $saved_seq_num
      set mom_coolant_status "ON"
}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
   MOM_do_template manual_tool_change
   PB_CMD_start_of_operation_force_addresses
}


#=============================================================
proc PB_CMD_start_of_operation_force_addresses { } {
#=============================================================
  MOM_force once  M_spindle X Y Z F
}


#=============================================================
proc MOM_load_tool { } {
#=============================================================
   global mom_tool_change_type mom_manual_tool_change
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}

#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
  global first_tool ; set first_tool 1
}

#=============================================================
proc MOM_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
}

#=============================================================
proc MOM_tool_preselect { } {
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
  global mom_warning_info
  set mom_warning_info "WARNING:     '242'   \[ tool_preselect\]"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

#=============================================================
proc MOM_length_compensation { } {
#=============================================================
  global  mom_tool_text  mom_tool_adjust_register
  global  mom_length_comp_register   mom_length_comp_register_text
  global  mom_adjust_mode ; set mom_adjust_mode  OFF
  MOM_suppress once D

  if {$mom_length_comp_register<0} { MOM_force once G_adjust ; return ; }

  TOOL_SET MOM_length_compensation
  if {[info exists mom_length_comp_register_text]} {
     if {$mom_length_comp_register_text != ""} {
     	switch [string toupper $mom_length_comp_register_text] {
     		PLUS    { set mom_adjust_mode  PLUS  ; }
     		MINUS   { set mom_adjust_mode  MINUS ; }
     		+       { set mom_adjust_mode  PLUS  ; }
     		-       { set mom_adjust_mode  MINUS ; }
     		OFF     { set mom_adjust_mode  OFF ; }
     		default { ; }
     		}
     }
  }

  MOM_force once G_adjust
  if {"$mom_adjust_mode"!="OFF"} {
     MOM_force once Z D
  }
  return ;
}


#=============================================================
proc MODES_SET { } {
#=============================================================
   global mom_machine_mode  mom_feed_set_mode  mom_feed_rate_output_mode
   global mom_output_mode  mom_arc_mode
   global mom_parallel_to_axis  mom_modes_text
   global mom_warning_info

; # "ABSOLUTE", "INCREMENTAL"
  switch $mom_output_mode {
    ABSOLUTE { set isincr OFF }
    default  { set isincr ON }
  }
  MOM_incremental $isincr X Y Z  R1 R2

; # "LINEAR", "CIRCULAR"
  if {$mom_arc_mode == "LINEAR"} {
  } elseif {$mom_arc_mode == "CIRCULAR"} {
  }

# "OFF", "IPM", "IPR", "MMPM", "MMPR", "INVERSE"
  switch $mom_feed_rate_output_mode {
    MMPM { ; }
    OFF  { ; }
    default  {
       set mom_warning_info "WARNING:    '242'   / (     /)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set mom_feed_rate_output_mode  "MMPM"
     }
  }

# "ZAXIS", "WAXIS", "UAXIS"
  switch $mom_parallel_to_axis {
    ZAXIS { ; }
    default  {
       set mom_warning_info "WARNING:     Z (    Z)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set mom_parallel_to_axis  "ZAXIS"
     }
  }

# "MILL", "TURN", "PUNCH", "LASER", "TORCH", "WIRE"
  switch $mom_machine_mode {
    MILL { ; }
    default  {
       set mom_warning_info "WARNING:        2.5 (    MILL)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
       set  mom_machine_mode  "MILL"
     }
  }

}

#=============================================================
proc MOM_set_modes { } {
#=============================================================
# This procedure is executed for the Set Mode command.
   global mom_machine_mode  mom_feed_set_mode
   global mom_output_mode  mom_arc_mode
   global mom_parallel_to_axis  mom_modes_text
   global mom_warning_info

   MODES_SET

   global mom_prefun  mom_prefun_text
   ;#  COARSE/FINE
   if {[info exists  mom_modes_text]} {
      switch [string toupper $mom_modes_text] {
        COARSE {
            set mom_prefun 36 ; MOM_prefun ;
            set mom_warning_info "WARNING:          . (   G$mom_prefun)\n"
            append mom_warning_info "\t          mom_arc_mode=CIRCULAR"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
        FINE {
            set mom_prefun 37 ; MOM_prefun ;
            set mom_warning_info "WARNING:           ( G$mom_prefun)\n"
            append mom_warning_info "\t          mom_arc_mode=LINEAR"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
         default {
          set mom_warning_info "WARNING:   \[$mom_modes_text\].  \[MOM_set_modes\]"
          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
      }
   }

}


#=============================================================
proc MOM_delay { } {
#=============================================================
# This procedure is executed when the Delay command is activated.
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time
  global mom_warning_info

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {
         set delay_time $mom_delay_revs ;
         set mom_warning_info "WARNING:      . !"
         MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
      }
    }
   MOM_do_template delay
}


#=============================================================
proc MOM_opstop { } {
#=============================================================
   MOM_do_template opstop
}


#=============================================================
proc MOM_auxfun { } {
#=============================================================
 global mom_auxfun_text  mom_auxfun_text_defined
 MOM_suppress once Text
 if {[info exists  mom_auxfun_text]} {
    if {$mom_auxfun_text!=""} { MOM_force  once  Text }
   }
 MOM_do_template auxfun
}


#=============================================================
proc MOM_prefun { } {
#=============================================================
 global mom_prefun_text  mom_prefun_text_defined
 MOM_suppress once Text
 if {[info exists mom_prefun_text]} {
    if {$mom_prefun_text!=""} { MOM_force  once  Text }
   }
 MOM_do_template prefun
}


#=============================================================
proc MOM_stop { } {
#=============================================================
   MOM_do_template stop
}


#=============================================================
proc MOM_text {} {
#=============================================================
# This procedure is executed when the Text command is activated.

  global mom_user_defined_text mom_record_text mom_record_fields mom_field_count
  global mom_Instruction
  global mom_sys_control_out mom_sys_control_in
  global mom_operator_message mom_operator_message_defined
  global mom_pprint_defined mom_pprint
  global mom_warning_info

  switch [string toupper $mom_record_fields(0)] {
   "SET"  { ; }
  "PPRINT" {
           set mom_pprint_defined 1
           set mom_pprint $mom_record_text
           MOM_pprint
           }
  "DISPLY" {
           set mom_operator_message_defined 1
           set mom_operator_message $mom_record_text
           MOM_operator_message
          }
  "INSERT" {
           if {[info exists mom_record_fields(1)]}  {
              set mom_Instruction [string toupper $mom_record_text ] ; #$mom_record_fields(1)] ;
              MOM_insert
              set mom_warning_info "WARNING:    'INSERT/$mom_Instruction' -  \n"
              MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
         }
  "PARTNO" { ; #   ()
           global partno_program
           set partno_program  "" ;
           set str "User Defined"
           if {[info exists  mom_record_fields(1)]} {
             set partno_program $mom_record_text ; # $mom_record_fields(1)
           }  else  {
              set RNseed [clock clicks] ;
              set RNseed [expr (30903 * ($RNseed & 65535) + ($RNseed>>16))]
              set RNseed [expr (($RNseed & 65535)/65535.0)]
              set RNseed [expr $RNseed*100000.0]
              set RNseed [expr int($RNseed)]
              set partno_program [format "%5d" $RNseed]
              set str "."
           }
           set mom_warning_info "<!--\n PARTNO-> \[  () - !   \]=$partno_program ($str)\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
  "REWIND" {
            global mom_sys_end_of_program_code mom_sys_rewind_code
            set mom_sys_end_of_program_code $mom_sys_rewind_code
            set mom_warning_info "<!--\n REWIND-> \[ \]=M30;\n-->"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
  "MACALL" { ; #  
           set n 0
           if {[info exists mom_record_fields(1)]} {
             set str  $mom_record_fields(1);
             if [catch {expr {2 * $str}}] { set str 0 ; }
             if {$str<0} { set str 0 ; }
             set n [expr int($str) ];
            }
           set m 0 ;
           if {[info exists mom_record_fields(2)]} {
             if {[string toupper $mom_record_fields(2)]=="REPEAT"} {
               if {[info exists mom_record_fields(3)]} {
                  set str  $mom_record_fields(3);
                  if [catch {expr {2 * $str}}] { set str 0 ; }
                  if {$str<0} { set str 0 ; }
                  set m [expr int($str) ]
                }
              } else {
                  set str  $mom_record_fields(2);
                  if [catch {expr {2 * $str}}] { set str 0 ; }
                  if {$str<0} { set str 0 ; }
                  set m [expr int($str) ]
                }
            }
           global  start_subprogram_code ;
           if {$m==0} { set m  1 ; }
           if {$m>99} { set m  99 ; }
           set m [ expr $m/100.0 ] ;
           set tm [ expr $n+$m ] ;
           set start_subprogram_code $tm ;
           MOM_force once  L_start
           MOM_do_template  start_of_subprogram ;
           set mom_warning_info "<!--\n MACALL-> \[ \]=$start_subprogram_code;\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
  "MACND" { ; #  
           global flag_subprogram; set flag_subprogram 0 ;
           MOM_do_template  end_of_subprogram ;
           MOM_do_template  end_of_program ;
           global mom_sys_seqnum_start  mom_sys_seqnum_incr  mom_sys_seqnum_freq ;
           MOM_set_seq_off
           MOM_reset_sequence $mom_sys_seqnum_start  $mom_sys_seqnum_incr  $mom_sys_seqnum_freq ;
           MOM_set_seq_on
           set mom_warning_info "<!--\n MACND-> \[ \];\n-->"
           MOM_output_to_listing_device $mom_warning_info  ; MOM_catch_warning ;
           }
  "MACST" {  ; #  () 
           global number_subprogram ; incr number_subprogram ;
           global flag_subprogram; set flag_subprogram 1 ;
           set n 0
           if {[info exists mom_record_fields(1)]} {
             set str [string toupper $mom_record_fields(1)]
             if [catch {expr {2 * $str}}] { set str 0 ; }
             if {$str<0} { set str 0 ; }
             set n [expr int($str) ];
            }
           set str "" ;
           for { set i 2 } { $i<$mom_field_count } { incr i } {
            if {[info exists mom_record_fields($i)]} {
             append str [string toupper $mom_record_fields($i)];
            }
           }
           if {$n>99} {
             set mom_warning_info "WARNING:   > 99 = ($n)\n-->"
             MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
           global def_subprogram_code  subprogram_text
           set def_subprogram_code $n
           set subprogram_text $str ;
           MOM_suppress once Text
           if {[info exists  subprogram_text]} {
             if {$subprogram_text != ""} { MOM_force  once  Text }
           }

           MOM_set_seq_off
           MOM_force once  L_def
           MOM_do_template def_of_subprogram
           MOM_reset_sequence [expr $n * 1000 ]  1 1
           MOM_set_seq_on
           set mom_warning_info "<!--\n MACST-> \[ () \];\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
  "STLOOP" { ; #   
           set n 0
           if {[info exists mom_record_fields(1)]} {
             set str  $mom_record_fields(1);
             if [catch {expr {2 * $str}}] { set str 0 ; }
             if {$str<0} { set str 0 ; }
             set n [ expr int($str) ] ;
            }
           set str "" ;
           for { set i 2 } { $i<$mom_field_count } { incr i } {
            if {[info exists mom_record_fields($i)]} {
             append str [string toupper $mom_record_fields($i)];
            }
           }
           global stloop_text  stloop_code
           set stloop_code  $n  ;
           set stloop_text $str ;
           MOM_suppress once Text
           if {[info exists stloop_text]} {
             if {$stloop_text != ""} { MOM_force  once  Text }
           }
           MOM_force once H
           MOM_do_template stloop
           set mom_warning_info "<!--\n STLOOP-> \[  \]  =$stloop_code ;\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          }
  "NDLOOP" { ; #   
            global mom_auxfun mom_auxfun_text ;
            set mom_auxfun 20 ;set mom_auxfun_text "" ; MOM_auxfun ;
            set mom_warning_info "<!--\n NDLOOP-> \[  \]=$mom_auxfun ;\n-->"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
           }
  "SAFETY" { ; #       
           switch [string toupper $mom_record_fields(1)] {
            "FEED" { set str 20 ; }
            "SPINDLE" { set str 21 ; }
            "ON" { set str 22 ; }
            "OFF" { set str 23 ; }
            default {
              set mom_warning_info "WARNING:   !($mom_user_defined_text)"
              MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
              MOM_output_literal $mom_user_defined_text
              return ;
              }
            }
           global mom_prefun mom_prefun_text ; set mom_prefun $str ; set mom_prefun_text "" ;
           MOM_prefun ;
           set mom_warning_info "<!--\n SAFETY-> [string toupper $mom_record_fields(1)] \[      \]=$str ;\n-->"
           MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
  "SELECT" { ; #  
           switch [string toupper $mom_record_fields(1)] {
             "PALLET" {
                       if {[info exists mom_record_fields(2)]} {
                          set str  $mom_record_fields(2);
                          if [catch {expr {2 * $str}}] { set str 0 ; }
                          global mom_auxfun mom_auxfun_text ;
                          if {$str<60 || $str>63} {
                            if {$str<0} { set str 0 ; }
                            if {$str>3} { set str 3 ; }
                            set str [expr 60 + $str] ;
                           }
                          set mom_auxfun [expr $str] ; set mom_auxfun_text "" ; MOM_auxfun  ; #MOM_output_literal "M$str"
                          set mom_warning_info "<!--\n SELECT-> PALLET \[ \]\n =$mom_auxfun ;\n-->"
                          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
                        }
                      }
              default {
                       set mom_warning_info "WARNING:   !($mom_user_defined_text)"
                       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
                      }
            }
          }
  "SLOWDN" {  ; #    
		catch { PB_slowdn }
          }
  "TIME" {
          global mom_time ;
          set  mom_time  ON ;
          if {[info exists mom_record_fields(1)]} {
           if {$mom_record_fields(1) == "OFF"} { set  mom_time  OFF ; }
           }
          set mom_warning_info "<!--\n TIME-> TIME \[ \]\n =$mom_time ;\n-->"
          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
         }
  "ZERO" {
          global  mom_work_coordinate_number
          set mom_work_coordinate_number $mom_record_fields(1)
           MOM_zero
         }
 default {
            set mom_warning_info "WARNING:   !($mom_user_defined_text)"
            MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
            MOM_output_literal $mom_user_defined_text
         }
  }
}

#=============================================================
proc  MOM_clamp {} {
#=============================================================
#     G      .
 global mom_clamp_status mom_clamp_axis mom_clamp_text
 global mom_auxfun mom_auxfun_text ;
 global mom_warning_info

 if {[info exists mom_clamp_text]} {
   if {$mom_clamp_text != ""} { set mom_auxfun_text $mom_clamp_text }
 }

if {[string toupper $mom_clamp_status]=="OFF"} {
 switch [string toupper $mom_clamp_axis] {
  "XAXIS" { set str 79 ; }
  "YAXIS" { set str 81 ; }
  "ZAXIS" { set str 83 ; }
  "AAXIS" { set str 85 ; }
   default
         {
          set mom_warning_info "WARNING:    ( X,Y,Z,A())"
          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          return ;
         }
  }
 set mom_auxfun $str ; MOM_auxfun  ; return ;
}

if {[string toupper $mom_clamp_status]=="ON"} {
 switch [string toupper $mom_clamp_axis] {
  "XAXIS" { set str 78 ; }
  "YAXIS" { set str 80 ; }
  "ZAXIS" { set str 82 ; }
  "AAXIS" { set str 84 ; }
   default
         {
          set mom_warning_info "WARNING:    ( X,Y,Z,A())"
          MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
          return ;
         }
  }
 set mom_auxfun $str ; MOM_auxfun ; return ;
}

 set mom_warning_info "WARNING:    ( \{X,Y,Z,A()\}+ \{ON  OFF\})"
 MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

#=============================================================
proc MOM_lock_axis { } {
#=============================================================
#     G      .
 global mom_warning_info
 set mom_warning_info "WARNING:  \[lock_axis\]  "
 MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}

#=============================================================
proc  MOM_pprint {} {
#=============================================================
#___ This procedure is executed when the Text command is activated.
 global mom_pprint ;
 global mom_warning_info

 if {[info exists mom_pprint]} {
  if {$mom_pprint!=""} {
     set var1 "" ;
     set st [regsub -nocase  -- {(%)+}  $mom_pprint  ""  var1 ] ; set mom_pprint $var1 ;
     set st [regsub -nocase  -- {(:)+}  $mom_pprint  ""  var1 ] ; set mom_pprint $var1 ;
     set st [regexp -nocase -- {[a-z]} $mom_pprint var1]
     if {$st!=0} {
       set mom_warning_info "WARNING:       "
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     }
     MOM_output_literal "($mom_pprint)"
   }
  }

}

#=============================================================
proc  MOM_operator_message {} {
#=============================================================
#__This procedure is executed when the Operator Message command is activated.
 global mom_operator_message  mom_operator_message_defined
 global mom_warning_info

  if {[info exists mom_operator_message]} {
    if {$mom_operator_message!=""} {
     set var1 "" ;
     set st [regsub -nocase  -- {(%)+}  $mom_operator_message  ""  var1 ] ; set mom_operator_message $var1 ;
     set st [regsub -nocase  -- {(:)+}  $mom_operator_message  ""  var1 ] ; set mom_operator_message $var1 ;
     set st [regexp -nocase -- {[a-z]} $mom_operator_message  var1]
     if {$st!=0} {
       set mom_warning_info "WARNING:     -  "
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     }
     MOM_output_literal "($mom_operator_message)"
    }
  }

}

#=============================================================
proc  MOM_zero {} {
#=============================================================
#     G      .
#         Fanuc.
#   G   ZERO/CHECK, ZERO/ON, ZERO/OFF, ZERO/THRU,   G   ZERO/n.
 global mom_sys_wcs_change_code mom_work_coordinate_number
 global mom_warning_info

 if {$mom_work_coordinate_number<0} {
  if {$mom_work_coordinate_number==-1} {
     MOM_force  once  G_return
     MOM_do_template sys_ref_point_return
     MOM_suppress always G_return
     set mom_warning_info ":         (G25) -  1     (work_coordinate_number=$mom_work_coordinate_number)"
     MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     return ;
   }
  if {$mom_work_coordinate_number==-2} {
     MOM_force  once  G_return
     set mom_warning_info ":      (G26),    (work_coordinate_number=$mom_work_coordinate_number)"
     MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     return ;
   }
 }

 if {$mom_work_coordinate_number<0 || $mom_work_coordinate_number>4} {
   set mom_warning_info "WARNING: work_coordinate_number=\[0 (),1,2,3,4\]"
   MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
 }
 set mom_sys_wcs_change_code [ expr ($mom_sys_wcs_change_code + $mom_work_coordinate_number)]
 MOM_force once G_return G_mode G_cutcom
 MOM_do_template sys_wcs_change

 return ;
}

#=============================================================
proc MOM_sequence_number { } {
#=============================================================
   SEQNO_SET
}

#=============================================================
proc MOM_origin {} {
#=============================================================
  global mom_origin_point ;
  global mom_warning_info ;
  set mom_warning_info "WARNING:   X, Y, Z -  "
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


##############################################################

#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}


#=============================================================
proc PB_CMD_force_addresses { type } {
; #      ( )
#=============================================================
  MOM_force once G_cutcom  G_mode
  MOM_force once G G_motion
  MOM_force once X Y Z F S
  MOM_force once M_spindle M_coolant
}

##############################################################CYCLES

proc CYCLE_SET { } {
#=============================================================
  global cycle_name
  WORKPLANE_SET
  MOM_force once L_motion ; #X Y Z R1 R2
  if { [string first DWELL $cycle_name] != -1 } { ; }
  if { [string first NODRAG $cycle_name] != -1 } { ; }
  if { [string first DEEP $cycle_name]!= -1 } { ; }
  if { [string first BREAK_CHIP $cycle_name]  != -1 } { ; }
}

#=============================================================
proc MOM_cycle_off { } {
#=============================================================
  global cycle_name
  MOM_force once G_motion Z F ;
  switch $cycle_name {
   BORE_DWELL  { MOM_force once S ; }
   BORE_MANUAL  { MOM_force once S ; }
   BORE_MANUAL_DWELL  { MOM_force once S ; }
  }
  set cycle_name OFF
  
  MOM_do_template cycle_off
}

#=============================================================
proc MOM_cycle_plane_change { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag TRUE
  global mom_pos mom_prev_pos

  if {$mom_pos(2) <= $mom_prev_pos(2) } {
   	MOM_do_template rapid_xy
   	MOM_do_template rapid_z
   } else {
   	MOM_do_template rapid_z
   	MOM_do_template rapid_xy
    }
}


#=============================================================
proc MOM_drill { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_drill
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_dwell_move { } {
#=============================================================
  global cycle_init_flag
   MOM_do_template cycle_drill_dwell
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_deep { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DEEP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_deep_move { } {
#=============================================================
  global cycle_init_flag
  MOM_do_template cycle_drill_deep
   set cycle_init_flag FALSE
}

#=============================================================
proc MOM_drill_break_chip { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_BREAK_CHIP
   CYCLE_SET
}

#=============================================================
proc MOM_drill_break_chip_move { } {
#=============================================================
  global cycle_init_flag
   MOM_do_template cycle_drill_break_chip
   set cycle_init_flag FALSE
}

#=============================================================
proc MOM_drill_peck { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL
   CYCLE_SET
}

#=============================================================
proc MOM_drill_peck_move { } {
#=============================================================
  global cycle_init_flag
   MOM_do_template cycle_drill
   set cycle_init_flag FALSE
}

#=============================================================
proc MOM_tap { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
   set cycle_init_flag TRUE
   set cycle_name TAP
   CYCLE_SET
}

#=============================================================
proc MOM_tap_move { } {
#=============================================================
  global cycle_init_flag
   MOM_do_template cycle_tap
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
   set cycle_init_flag TRUE
   set cycle_name BORE
   CYCLE_SET
  global mom_warning_info
  set mom_warning_info "\nWARNING:       \[bore\]\n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
   set cycle_init_flag TRUE
   set cycle_name BORE_DRAG
   CYCLE_SET
}


#=============================================================
proc MOM_bore_drag_move { } {
#=============================================================
  global cycle_init_flag
   MOM_do_template cycle_bore_drag
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_no_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag
   set cycle_init_flag TRUE
   set cycle_name BORE_NO_DRAG
   CYCLE_SET
  global mom_warning_info
  set mom_warning_info "\nWARNING:   C   \[bore_no_drag\]    \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_no_drag_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_manual { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_MANUAL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_manual_move { } {
#=============================================================
  global cycle_init_flag
   MOM_do_template cycle_bore_manual
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_dwell_move { } {
#=============================================================
  global cycle_init_flag
   MOM_do_template cycle_bore_dwell
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_back { } {
#=============================================================
  global cycle_name ;    set cycle_name BORE_BACK
  global cycle_init_flag ;  set cycle_init_flag TRUE
    CYCLE_SET
  global mom_warning_info
  set mom_warning_info "\nWARNING:    \[bore_back\]    \n     Point-to-Point\n"
  MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
}


#=============================================================
proc MOM_bore_back_move { } {
#=============================================================
  global cycle_init_flag
  set cycle_init_flag FALSE
  MOM_linear_move
}


#=============================================================
proc MOM_bore_manual_dwell { } {
#=============================================================
  global cycle_name ;     set cycle_name BORE_MANUAL_DWELL
  global cycle_init_flag ;   set cycle_init_flag TRUE
  CYCLE_SET
}

#=============================================================
proc MOM_bore_manual_dwell_move { } {
#=============================================================
  global cycle_init_flag ;
  MOM_do_template cycle_bore_manual_dwell
  set cycle_init_flag FALSE
}
##############################################################

########################
# Redefine FEEDRATE_SET -     MMPM ;   - 
########################
if [llength [info commands ugpost_FEEDRATE_SET] ] {
   rename ugpost_FEEDRATE_SET ""
}

if [llength [info commands FEEDRATE_SET] ] {
   rename FEEDRATE_SET ugpost_FEEDRATE_SET
} else {
   proc ugpost_FEEDRATE_SET {} {}
}


#=============================================================
proc FEEDRATE_SET {} {
#=============================================================
   if [llength [info commands PB_CMD_kin_feedrate_set] ] {
      PB_CMD_kin_feedrate_set
   } else {
      ugpost_FEEDRATE_SET
   }
}

proc ASK_FEEDRATE_FPM {} {
#_______________________________________________________________________________
# returns feed rate IN or MM per min
#_______________________________________________________________________________
  global mom_feed_rate

  if {[hiset mom_feed_rate]} {
    global mom_kin_rapid_feed_rate
    if {$mom_feed_rate>=$mom_kin_rapid_feed_rate} {
  	set mom_feed_rate $mom_kin_rapid_feed_rate
    }
    return $mom_feed_rate
  } else {
    set mom_warning_info "FEED RATE UNDEFINED" ; MOM_catch_warning ; return 0.0
  }
}

set feed 0.0 ; set feed_mode MMPM

#=============================================================
proc PB_CMD_kin_feedrate_set { } {
#=============================================================
# This procedure supercedes the functionalites provided by the
# FEEDRATE_SET in ugpost_base.tcl.  Post Builder automatically
# generates proper call sequences to this procedure in the
# Event handlers.
#
# This procedure must be used in conjunction with ugpost_base.tcl.
#
  global   feed com_feed_rate
  global   mom_feed_rate_output_mode super_feed_mode feed_mode
  global   mom_cycle_feed_rate_mode mom_cycle_feed_rate
  global   mom_cycle_feed_rate_per_rev
  global   mom_motion_type
  global   mom_warning_info
  global   Feed_IPM Feed_IPR Feed_MMPM Feed_MMPR Feed_INV
  global   mom_sys_feed_param
  global   mom_sys_cycle_feed_mode

  set super_feed_mode $mom_feed_rate_output_mode

  set f_pm [ASK_FEEDRATE_FPM] ; set f_pr [ASK_FEEDRATE_FPR]

  switch $mom_motion_type {

    CYCLE {
      if [info exists mom_sys_cycle_feed_mode] {
         if { $mom_sys_cycle_feed_mode != "Auto" } {
            set mom_cycle_feed_rate_mode $mom_sys_cycle_feed_mode
         }
      }
      if {[hiset mom_cycle_feed_rate_mode]} { set super_feed_mode $mom_cycle_feed_rate_mode }
      if {[hiset mom_cycle_feed_rate]} { set f_pm $mom_cycle_feed_rate }
      if {[hiset mom_cycle_feed_rate_per_rev]} { set f_pr $mom_cycle_feed_rate_per_rev }
    }

    FROM -
    RETRACT -
    RETURN -
    LIFT -
    TRAVERSAL -
    GOHOME  -
    GOHOME_DEFAULT -
    RAPID {
      SUPER_FEED_MODE_SET RAPID
    }

    default {
      if {[EQ_is_zero $f_pm] && [EQ_is_zero $f_pr]} {
        SUPER_FEED_MODE_SET RAPID
      } else {
        SUPER_FEED_MODE_SET CONTOUR
      }
    }
  }

  set feed_mode $super_feed_mode

 # Adjust feedrate format per Post output unit again.
  global mom_kin_output_unit
  if { $mom_kin_output_unit == "IN" } {
     switch $feed_mode {
       MMPM {
         set feed_mode "IPM"
         CATCH_WARNING "Feedrate mode MMPM changed to IPM"
       }
       MMPR {
         set feed_mode "IPR"
         CATCH_WARNING "Feedrate mode MMPR changed to IPR"
       }
     }
    CATCH_WARNING " 2C42     - "
    MOM_abort "\n\n\t 2C42     - \n\n"
  } else {
     switch $feed_mode {
       IPM {
         set feed_mode "MMPM"
         CATCH_WARNING "Feedrate mode IPM changed to MMPM .  2C42      IPM"
       }
       IPR {
         set feed_mode "MMPR"
         CATCH_WARNING "Feedrate mode IPR changed to MMPR .  2C42      IPR"
       }
     }
  }

 global  mom_path_name

  switch $feed_mode {
    IPM     -
    MMPM    { set feed $f_pm }
    IPR     -
    MMPR    {
    	        CATCH_WARNING " 2C42   c   - MMPR. Operation $mom_path_name \nFeedrate mode MMPR changed to MMPM"
    	        set feed $f_pm
    	        set feed_mode "MMPM"
     }
    DPM     {
    	#returns feed rate in degrees per min
    	CATCH_WARNING " 2C42   c   - DPM. Operation $mom_path_name "
    	set feed [PB_CMD_FEEDRATE_DPM]
     }
    FRN     -
    INVERSE {
    	# returns feed rate number in inverse time
    	CATCH_WARNING " 2C42   c   - FRN , INVERSE . Operation $mom_path_name "
    	set feed [PB_CMD_FEEDRATE_NUMBER]
     }
    default { set mom_warning_info "INVALID FEED RATE MODE" ; MOM_catch_warning ; return }
  }


 # Post Builder provided format for the current mode:
  if [info exists mom_sys_feed_param(${feed_mode},format)] {
    MOM_set_address_format F $mom_sys_feed_param(${feed_mode},format)
  } else {
    switch $feed_mode {
      IPM     -
      MMPM    -
      IPR     -
      MMPR    -
      DPM     -
      FRN     { MOM_set_address_format F Feed_${feed_mode} }
      INVERSE { MOM_set_address_format F Feed_INV }
    }
  }

 # Commentary output
  set com_feed_rate $f_pm


 # Execute user's commnad, if any.
  if [llength [info commands "PB_CMD_FEEDRATE_SET"]] {
     PB_CMD_FEEDRATE_SET
  }
}


#=============================================================
proc CATCH_WARNING { msg } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number

   set level [info level]
   set call_stack ""
   for {set i 1} {$i < $level} {incr i} {
      set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
   }
   set mom_warning_info "$msg ($mom_motion_event $mom_event_number) " ; # $call_stack
   MOM_output_to_listing_device $mom_warning_info
   MOM_catch_warning
}


############################################################################################################################

#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}2C42_user.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }
